<template>
	<div class="wrapper">
		<div class="wrapperBlocks">
			<div class="blockStretch">
				<h2 class="head">Форма ФИО</h2>
				<FormValidator ref="authForm">
					<form @submit.prevent="onValidate">
						<div class="login-form__network-error" v-if="loginFormError">
							{{ loginFormError }}
						</div>
							<FieldValidator 
								name="userName" 
								rules="required|max:40|min:8|regex:^[а-яА-Я_ ]+$" 
								mode="lazy" 
								slim 
								v-slot="{ errors }"
							>
								<input 
									type="text"
									name="userName"
									class="inputName"
									:class="{ 'is-invalid': errors.length > 0 }"
									placeholder="ФИО" 
									v-model="loginForm.userName"
								/>
								<div 
									v-for="(error, key) in errors" 
									:key="`userName-${key}`" 
									class="invalid-feedback"
									v-show="errors"
								>
									{{ error }}
								</div>
							</FieldValidator>
							<div class="sendBtn">
								<button class="btn btn-success" type="submit">Отправить</button>
							</div>
					</form>	
				</FormValidator>
			</div>
		</div>
		<div class="wrapperBlocks" id="block2">
			<div class="blockStretch">
				<h2 class="head">Изменения</h2>
				<h4 v-if="changesArray.length < 1">Нет изменений...</h4>
				<span class="changeBlock" v-else v-for="change in changesArray">
					<div><strong>Имя: </strong>{{ change.name }}</div>
					<div><strong>Время: </strong>{{ change.time }}</div>
				</span>
			</div>
		</div>
	</div>
</template>

<script>
//Mixin с методом validationMethod() для валидации формы
import { mixinValidation } from '@/mixins/validation.mixin'
//плагин для валидации(Vee validate)
import { ValidationObserver, ValidationProvider } from 'vee-validate'
//подключаю хранилище
import { mapGetters, mapActions } from 'vuex'

export default {
	name: 'IndexPage',
	mixins: [mixinValidation],
	components: {
		FormValidator: ValidationObserver,
		FieldValidator: ValidationProvider
	},
	computed: {
		...mapGetters({
			item: 'user/item'
		})
	},
	data: () => ({
		loginForm: {
			userName: ''
		},
		changesArray: [], //массив для списка измениний
		loginFormError: null,
	}),
	methods: {
		...mapActions({
			'fetchEmail': 'user/fetchEmail',
			'updateName': 'user/update'
		}),
		async onValidate() {
			const isCorrect = await this.$refs.authForm.validate()
			
			if(isCorrect&&this.validationMethod()) { // проверка валидации из mixin и vee validate
				try {
					//заполнение массива списка изменений
					if(this.item.userName != this.loginForm.userName){
						const now = new Date();
						const dateString = `${now.getDay()}/${now.getMonth()}/${now.getFullYear()} ${now.toTimeString().substr(0, 8)}`
						const changeObj = {
							name: this.loginForm.userName, 
							time: dateString
						}
						this.changesArray.push(changeObj)
					}
					//отправка на обновление ФИО
					await this.updateName({
						id: this.item._id,
						payload: this.loginForm,
					})
					
				} catch (err) {
					console.log('что-то пошло не так...', err)
				}
			}
		}
	},
	async mounted() {
		//нахожу юзера по данным query 
		await this.fetchEmail(this.$route.query.email)
		this.loginForm.userName = this.item.userName
	}
}
</script>

<style lang="scss">
.wrapper{
	white-space: nowrap;
}
.head{
	text-align: center;
	width: 100%;
	background: #4a5760;
	color: white;
	height: 55px;
}
.wrapperBlocks {
	white-space: normal;	
	display: inline-block;
	width: 46%;
	height: 50%;
	vertical-align: top;
	background: #fff2e1;
	border: 2px solid #2c4659;
	text-align: center;
	
}
.wrapper .wrapperBlocks:first-child {
	margin-right: 8%;
}
.blockStretch {
	height: 50vh;
}
.changeBlock {
	display:flex;
	flex-direction:row;
	justify-content: space-between;
	padding: 10px;
	margin: 5px;
	background: white;
	border: 2px solid #2c4659;
}
.inputName{
	margin-top: 20px;
	width: 70%;
}
.sendBtn{
	margin-top: 20px;
}
.login-form__network-error{
	border-radius: 6px;
	padding: 10px;
	color: #8f0000;
	background: #eba0a0
}
#block2{
	overflow-y: scroll;
}

</style>

